From be887d7884d4c14a3b0763c357506ae046e4e2a9 Mon Sep 17 00:00:00 2001
From: azv <azv@opencascade.com>
Date: Fri, 5 Aug 2016 15:21:34 +0300
Subject: [PATCH] 0027074: Support of multi-span cache in Geom[2d]Adaptor

The multi-span cache is stored as matrix (for surface) or vector (for curves) of caches. Each cell corresponds to a span. The cache is initialized on first call and destroyed when adaptor is destroyed.

1. Multi-span cache for curve and surfaces.
2. Revision of BSplSLib_Cache and small improvements.
3. Renew cache when loading same curve/surface into adaptor.
4. Optimizations for single-span cache
5. Remove unused constructors in BSpl*Lib_Cache classes
6. Allocate cache on first call, not when loading a curve/surface
7. Note in upgrade.md about multi-span implementation
---
 dox/dev_guides/upgrade/upgrade.md         |   8 +
 src/BSplCLib/BSplCLib_Cache.cxx           | 183 +++++------------
 src/BSplCLib/BSplCLib_Cache.hxx           | 116 ++++-------
 src/BSplCLib/BSplCLib_MultiSpanCache.gxx  | 158 +++++++++++++++
 src/BSplCLib/BSplCLib_MultiSpanCache.hxx  | 190 +++++++++++++++++
 src/BSplCLib/FILES                        |   2 +
 src/BSplSLib/BSplSLib_Cache.cxx           | 224 ++++++---------------
 src/BSplSLib/BSplSLib_Cache.hxx           |  95 ++++-----
 src/BSplSLib/BSplSLib_MultiSpanCache.cxx  | 235 ++++++++++++++++++++++
 src/BSplSLib/BSplSLib_MultiSpanCache.hxx  | 171 ++++++++++++++++
 src/BSplSLib/FILES                        |   2 +
 src/Geom2dAdaptor/Geom2dAdaptor_Curve.cxx |  94 ++++-----
 src/Geom2dAdaptor/Geom2dAdaptor_Curve.hxx |   9 +-
 src/GeomAdaptor/GeomAdaptor_Curve.cxx     |  90 ++++-----
 src/GeomAdaptor/GeomAdaptor_Curve.hxx     |   9 +-
 src/GeomAdaptor/GeomAdaptor_Surface.cxx   | 102 +++++-----
 src/GeomAdaptor/GeomAdaptor_Surface.hxx   |  12 +-
 src/QABugs/QABugs_19.cxx                  |  64 ++++++
 tests/blend/simple/Q6                     |   2 +-
 tests/bugs/modalg_6/bug25613_1            |   2 +-
 tests/bugs/modalg_6/bug25613_2            |   2 +-
 tests/de/step_2/R2                        |   4 +-
 tests/de/step_2/T1                        |   4 +-
 tests/perf/bspline/hugenurbs              |  39 ++++
 tests/perf/bspline/multispan              |  64 ++++++
 25 files changed, 1273 insertions(+), 608 deletions(-)
 create mode 100644 src/BSplCLib/BSplCLib_MultiSpanCache.gxx
 create mode 100644 src/BSplCLib/BSplCLib_MultiSpanCache.hxx
 create mode 100644 src/BSplSLib/BSplSLib_MultiSpanCache.cxx
 create mode 100644 src/BSplSLib/BSplSLib_MultiSpanCache.hxx
 create mode 100644 tests/perf/bspline/hugenurbs
 create mode 100644 tests/perf/bspline/multispan

diff --git a/src/BSplCLib/BSplCLib_Cache.cxx b/src/BSplCLib/BSplCLib_Cache.cxx
index 59efb2f8f1..39e419bacf 100644
--- a/src/BSplCLib/BSplCLib_Cache.cxx
+++ b/src/BSplCLib/BSplCLib_Cache.cxx
@@ -33,88 +33,32 @@ static Standard_Real* ConvertArray(const Handle(TColStd_HArray2OfReal)& theHArra
 
 
 BSplCLib_Cache::BSplCLib_Cache()
+  : myIsRational(Standard_False),
+    mySpanStart(0.0),
+    mySpanLength(0.0),
+    mySpanIndex(0),
+    mySpanIndexMin(0),
+    mySpanIndexMax(0),
+    myDegree(0)
 {
-  myPolesWeights.Nullify();
-  myIsRational = Standard_False;
-  mySpanStart = 0.0;
-  mySpanLength = 0.0;
-  mySpanIndex = 0;
-  myDegree = 0;
-  myFlatKnots.Nullify();
-}
-
-BSplCLib_Cache::BSplCLib_Cache(const Standard_Integer&        theDegree,
-                               const Standard_Boolean&        thePeriodic,
-                               const TColStd_Array1OfReal&    theFlatKnots,
-                               const TColgp_Array1OfPnt2d&    thePoles2d,
-                               const TColStd_Array1OfReal*    theWeights)
-{
-  Standard_Real aCacheParam = theFlatKnots.Value(theFlatKnots.Lower() + theDegree);
-  BuildCache(aCacheParam, theDegree, thePeriodic, 
-             theFlatKnots, thePoles2d, theWeights);
-}
-
-BSplCLib_Cache::BSplCLib_Cache(const Standard_Integer&        theDegree,
-                               const Standard_Boolean&        thePeriodic,
-                               const TColStd_Array1OfReal&    theFlatKnots,
-                               const TColgp_Array1OfPnt&      thePoles,
-                               const TColStd_Array1OfReal*    theWeights)
-{
-  Standard_Real aCacheParam = theFlatKnots.Value(theFlatKnots.Lower() + theDegree);
-  BuildCache(aCacheParam, theDegree, thePeriodic, 
-             theFlatKnots, thePoles, theWeights);
 }
 
 
 Standard_Boolean BSplCLib_Cache::IsCacheValid(Standard_Real theParameter) const
 {
-  Standard_Real aNewParam = theParameter;
-  if (!myFlatKnots.IsNull())
-    PeriodicNormalization(myFlatKnots->Array1(), aNewParam);
-
-  Standard_Real aDelta = aNewParam - mySpanStart;
+  Standard_Real aDelta = theParameter - mySpanStart;
   return ((aDelta >= 0.0 || mySpanIndex == mySpanIndexMin) &&
           (aDelta < mySpanLength || mySpanIndex == mySpanIndexMax));
 }
 
-void BSplCLib_Cache::PeriodicNormalization(const TColStd_Array1OfReal& theFlatKnots, 
-                                           Standard_Real& theParameter) const
-{
-  Standard_Real aPeriod = theFlatKnots.Value(theFlatKnots.Upper() - myDegree) - 
-                          theFlatKnots.Value(myDegree + 1) ;
-  if (theParameter < theFlatKnots.Value(myDegree + 1))
-  {
-    Standard_Real aScale = IntegerPart(
-        (theFlatKnots.Value(myDegree + 1) - theParameter) / aPeriod);
-    theParameter += aPeriod * (aScale + 1.0);
-  }
-  if (theParameter > theFlatKnots.Value(theFlatKnots.Upper() - myDegree))
-  {
-    Standard_Real aScale = IntegerPart(
-        (theParameter - theFlatKnots.Value(theFlatKnots.Upper() - myDegree)) / aPeriod);
-    theParameter -= aPeriod * (aScale + 1.0);
-  }
-}
-
 
-void BSplCLib_Cache::BuildCache(const Standard_Real&           theParameter,
-                                const Standard_Integer&        theDegree,
-                                const Standard_Boolean&        thePeriodic,
-                                const TColStd_Array1OfReal&    theFlatKnots,
-                                const TColgp_Array1OfPnt2d&    thePoles2d,
-                                const TColStd_Array1OfReal*    theWeights)
+void BSplCLib_Cache::BuildCache(const Standard_Integer      theDegree,
+                                const Standard_Boolean      thePeriodic,
+                                const TColStd_Array1OfReal& theFlatKnots,
+                                const Standard_Integer      theCachedSpan,
+                                const TColgp_Array1OfPnt2d& thePoles2d,
+                                const TColStd_Array1OfReal* theWeights)
 {
-  // Normalize theParameter for periodical B-splines
-  Standard_Real aNewParam = theParameter;
-  if (thePeriodic)
-  {
-    PeriodicNormalization(theFlatKnots, aNewParam);
-    myFlatKnots = new TColStd_HArray1OfReal(1, theFlatKnots.Length());
-    myFlatKnots->ChangeArray1() = theFlatKnots;
-  }
-  else if (!myFlatKnots.IsNull()) // Periodical curve became non-periodical
-    myFlatKnots.Nullify();
-
   // Change the size of cached data if needed
   myIsRational = (theWeights != NULL);
   Standard_Integer aPWColNumber = myIsRational ? 3 : 2;
@@ -122,9 +66,7 @@ void BSplCLib_Cache::BuildCache(const Standard_Real&           theParameter,
     myPolesWeights = new TColStd_HArray2OfReal(1, theDegree + 1, 1, aPWColNumber);
 
   myDegree = theDegree;
-  mySpanIndex = 0;
-  BSplCLib::LocateParameter(theDegree, theFlatKnots, BSplCLib::NoMults(), 
-                            aNewParam, thePeriodic, mySpanIndex, aNewParam);
+  mySpanIndex = theCachedSpan;
   mySpanStart  = theFlatKnots.Value(mySpanIndex);
   mySpanLength = theFlatKnots.Value(mySpanIndex + 1) - mySpanStart;
   mySpanIndexMin = thePeriodic ? 0 : myDegree + 1;
@@ -136,24 +78,13 @@ void BSplCLib_Cache::BuildCache(const Standard_Real&           theParameter,
                        myPolesWeights->ChangeArray2());
 }
 
-void BSplCLib_Cache::BuildCache(const Standard_Real&           theParameter,
-                                const Standard_Integer&        theDegree,
-                                const Standard_Boolean&        thePeriodic,
-                                const TColStd_Array1OfReal&    theFlatKnots,
-                                const TColgp_Array1OfPnt&      thePoles,
-                                const TColStd_Array1OfReal*    theWeights)
+void BSplCLib_Cache::BuildCache(const Standard_Integer      theDegree,
+                                const Standard_Boolean      thePeriodic,
+                                const TColStd_Array1OfReal& theFlatKnots,
+                                const Standard_Integer      theCachedSpan,
+                                const TColgp_Array1OfPnt&   thePoles,
+                                const TColStd_Array1OfReal* theWeights)
 {
-  // Create list of knots with repetitions and normalize theParameter for periodical B-splines
-  Standard_Real aNewParam = theParameter;
-  if (thePeriodic)
-  {
-    PeriodicNormalization(theFlatKnots, aNewParam);
-    myFlatKnots = new TColStd_HArray1OfReal(1, theFlatKnots.Length());
-    myFlatKnots->ChangeArray1() = theFlatKnots;
-  }
-  else if (!myFlatKnots.IsNull()) // Periodical curve became non-periodical
-    myFlatKnots.Nullify();
-
   // Change the size of cached data if needed
   myIsRational = (theWeights != NULL);
   Standard_Integer aPWColNumber = myIsRational ? 4 : 3;
@@ -161,9 +92,7 @@ void BSplCLib_Cache::BuildCache(const Standard_Real&           theParameter,
     myPolesWeights = new TColStd_HArray2OfReal(1, theDegree + 1, 1, aPWColNumber);
 
   myDegree = theDegree;
-  mySpanIndex = 0;
-  BSplCLib::LocateParameter(theDegree, theFlatKnots, BSplCLib::NoMults(), 
-                            aNewParam, thePeriodic, mySpanIndex, aNewParam);
+  mySpanIndex = theCachedSpan;
   mySpanStart  = theFlatKnots.Value(mySpanIndex);
   mySpanLength = theFlatKnots.Value(mySpanIndex + 1) - mySpanStart;
   mySpanIndexMin = thePeriodic ? 0 : myDegree + 1;
@@ -176,15 +105,11 @@ void BSplCLib_Cache::BuildCache(const Standard_Real&           theParameter,
 }
 
 
-void BSplCLib_Cache::CalculateDerivative(const Standard_Real&    theParameter, 
-                                         const Standard_Integer& theDerivative, 
-                                               Standard_Real&    theDerivArray) const
+void BSplCLib_Cache::CalculateDerivative(const Standard_Real    theParameter, 
+                                         const Standard_Integer theDerivative, 
+                                               Standard_Real&   theDerivArray) const
 {
-  Standard_Real aNewParameter = theParameter;
-  if (!myFlatKnots.IsNull()) // B-spline is periodical
-    PeriodicNormalization(myFlatKnots->Array1(), aNewParameter);
-  aNewParameter = (aNewParameter - mySpanStart) / mySpanLength;
-
+  Standard_Real aNewParameter = (theParameter - mySpanStart) / mySpanLength;
   Standard_Real* aPolesArray = ConvertArray(myPolesWeights);
   Standard_Integer aDimension = myPolesWeights->RowLength(); // number of columns
 
@@ -225,13 +150,9 @@ void BSplCLib_Cache::CalculateDerivative(const Standard_Real&    theParameter,
 }
 
 
-void BSplCLib_Cache::D0(const Standard_Real& theParameter, gp_Pnt2d& thePoint) const
+void BSplCLib_Cache::D0(const Standard_Real theParameter, gp_Pnt2d& thePoint) const
 {
-  Standard_Real aNewParameter = theParameter;
-  if (!myFlatKnots.IsNull()) // B-spline is periodical
-    PeriodicNormalization(myFlatKnots->Array1(), aNewParameter);
-  aNewParameter = (aNewParameter - mySpanStart) / mySpanLength;
-
+  Standard_Real aNewParameter = (theParameter - mySpanStart) / mySpanLength;
   Standard_Real* aPolesArray = ConvertArray(myPolesWeights);
   Standard_Real aPoint[4];
   Standard_Integer aDimension = myPolesWeights->RowLength(); // number of columns
@@ -245,13 +166,9 @@ void BSplCLib_Cache::D0(const Standard_Real& theParameter, gp_Pnt2d& thePoint) c
     thePoint.ChangeCoord().Divide(aPoint[2]);
 }
 
-void BSplCLib_Cache::D0(const Standard_Real& theParameter, gp_Pnt& thePoint) const
+void BSplCLib_Cache::D0(const Standard_Real theParameter, gp_Pnt& thePoint) const
 {
-  Standard_Real aNewParameter = theParameter;
-  if (!myFlatKnots.IsNull()) // B-spline is periodical
-    PeriodicNormalization(myFlatKnots->Array1(), aNewParameter);
-  aNewParameter = (aNewParameter - mySpanStart) / mySpanLength;
-
+  Standard_Real aNewParameter = (theParameter - mySpanStart) / mySpanLength;
   Standard_Real* aPolesArray = ConvertArray(myPolesWeights);
   Standard_Real aPoint[4];
   Standard_Integer aDimension = myPolesWeights->RowLength(); // number of columns
@@ -266,12 +183,12 @@ void BSplCLib_Cache::D0(const Standard_Real& theParameter, gp_Pnt& thePoint) con
 }
 
 
-void BSplCLib_Cache::D1(const Standard_Real& theParameter, gp_Pnt2d& thePoint, gp_Vec2d& theTangent) const
+void BSplCLib_Cache::D1(const Standard_Real theParameter, gp_Pnt2d& thePoint, gp_Vec2d& theTangent) const
 {
   Standard_Integer aDimension = myPolesWeights->RowLength(); // number of columns
   Standard_Real aPntDeriv[8]; // result storage (point and derivative coordinates)
 
-  this->CalculateDerivative(theParameter, 1, aPntDeriv[0]);
+  CalculateDerivative(theParameter, 1, aPntDeriv[0]);
   if (myIsRational) // the size of aPntDeriv was changed by PLib::RationalDerivative
     aDimension -= 1;
 
@@ -279,12 +196,12 @@ void BSplCLib_Cache::D1(const Standard_Real& theParameter, gp_Pnt2d& thePoint, g
   theTangent.SetCoord(aPntDeriv[aDimension], aPntDeriv[aDimension + 1]);
 }
 
-void BSplCLib_Cache::D1(const Standard_Real& theParameter, gp_Pnt& thePoint, gp_Vec& theTangent) const
+void BSplCLib_Cache::D1(const Standard_Real theParameter, gp_Pnt& thePoint, gp_Vec& theTangent) const
 {
   Standard_Integer aDimension = myPolesWeights->RowLength(); // number of columns
   Standard_Real aPntDeriv[8]; // result storage (point and derivative coordinates)
 
-  this->CalculateDerivative(theParameter, 1, aPntDeriv[0]);
+  CalculateDerivative(theParameter, 1, aPntDeriv[0]);
   if (myIsRational) // the size of aPntDeriv was changed by PLib::RationalDerivative
     aDimension -= 1;
 
@@ -292,12 +209,12 @@ void BSplCLib_Cache::D1(const Standard_Real& theParameter, gp_Pnt& thePoint, gp_
   theTangent.SetCoord(aPntDeriv[aDimension], aPntDeriv[aDimension + 1], aPntDeriv[aDimension + 2]);
 }
 
-void BSplCLib_Cache::D2(const Standard_Real& theParameter, gp_Pnt2d& thePoint, gp_Vec2d& theTangent, gp_Vec2d& theCurvature) const
+void BSplCLib_Cache::D2(const Standard_Real theParameter, gp_Pnt2d& thePoint, gp_Vec2d& theTangent, gp_Vec2d& theCurvature) const
 {
   Standard_Integer aDimension = myPolesWeights->RowLength(); // number of columns
   Standard_Real aPntDeriv[12]; // result storage (point and derivatives coordinates)
 
-  this->CalculateDerivative(theParameter, 2, aPntDeriv[0]);
+  CalculateDerivative(theParameter, 2, aPntDeriv[0]);
   if (myIsRational) // the size of aPntDeriv was changed by PLib::RationalDerivative
     aDimension -= 1;
 
@@ -306,12 +223,12 @@ void BSplCLib_Cache::D2(const Standard_Real& theParameter, gp_Pnt2d& thePoint, g
   theCurvature.SetCoord(aPntDeriv[aDimension<<1], aPntDeriv[(aDimension<<1) + 1]);
 }
 
-void BSplCLib_Cache::D2(const Standard_Real& theParameter, gp_Pnt& thePoint, gp_Vec& theTangent, gp_Vec& theCurvature) const
+void BSplCLib_Cache::D2(const Standard_Real theParameter, gp_Pnt& thePoint, gp_Vec& theTangent, gp_Vec& theCurvature) const
 {
   Standard_Integer aDimension = myPolesWeights->RowLength(); // number of columns
   Standard_Real aPntDeriv[12]; // result storage (point and derivatives coordinates)
 
-  this->CalculateDerivative(theParameter, 2, aPntDeriv[0]);
+  CalculateDerivative(theParameter, 2, aPntDeriv[0]);
   if (myIsRational) // the size of aPntDeriv was changed by PLib::RationalDerivative
     aDimension -= 1;
 
@@ -321,16 +238,16 @@ void BSplCLib_Cache::D2(const Standard_Real& theParameter, gp_Pnt& thePoint, gp_
 }
 
 
-void BSplCLib_Cache::D3(const Standard_Real& theParameter, 
-                              gp_Pnt2d&      thePoint, 
-                              gp_Vec2d&      theTangent, 
-                              gp_Vec2d&      theCurvature,
-                              gp_Vec2d&      theTorsion) const
+void BSplCLib_Cache::D3(const Standard_Real theParameter, 
+                              gp_Pnt2d&     thePoint, 
+                              gp_Vec2d&     theTangent, 
+                              gp_Vec2d&     theCurvature,
+                              gp_Vec2d&     theTorsion) const
 {
   Standard_Integer aDimension = myPolesWeights->RowLength(); // number of columns
   Standard_Real aPntDeriv[16]; // result storage (point and derivatives coordinates)
 
-  this->CalculateDerivative(theParameter, 3, aPntDeriv[0]);
+  CalculateDerivative(theParameter, 3, aPntDeriv[0]);
   if (myIsRational) // the size of aPntDeriv was changed by PLib::RationalDerivative
     aDimension -= 1;
 
@@ -342,16 +259,16 @@ void BSplCLib_Cache::D3(const Standard_Real& theParameter,
   theTorsion.SetCoord(aPntDeriv[aShift], aPntDeriv[aShift + 1]);
 }
 
-void BSplCLib_Cache::D3(const Standard_Real& theParameter, 
-                              gp_Pnt&        thePoint, 
-                              gp_Vec&        theTangent, 
-                              gp_Vec&        theCurvature,
-                              gp_Vec&        theTorsion) const
+void BSplCLib_Cache::D3(const Standard_Real theParameter, 
+                              gp_Pnt&       thePoint, 
+                              gp_Vec&       theTangent, 
+                              gp_Vec&       theCurvature,
+                              gp_Vec&       theTorsion) const
 {
   Standard_Integer aDimension = myPolesWeights->RowLength(); // number of columns
   Standard_Real aPntDeriv[16]; // result storage (point and derivatives coordinates)
 
-  this->CalculateDerivative(theParameter, 3, aPntDeriv[0]);
+  CalculateDerivative(theParameter, 3, aPntDeriv[0]);
   if (myIsRational) // the size of aPntDeriv was changed by PLib::RationalDerivative
     aDimension -= 1;
 
diff --git a/src/BSplCLib/BSplCLib_Cache.hxx b/src/BSplCLib/BSplCLib_Cache.hxx
index 74bcd14d00..4c5a0e0acb 100644
--- a/src/BSplCLib/BSplCLib_Cache.hxx
+++ b/src/BSplCLib/BSplCLib_Cache.hxx
@@ -40,86 +40,64 @@ class BSplCLib_Cache : public Standard_Transient
 public:
   //! Default constructor
   Standard_EXPORT BSplCLib_Cache();
-  //! Constructor for caching of 2D curves
-  //! \param theDegree     degree of the curve
-  //! \param thePeriodic   identify the curve is periodic
-  //! \param theFlatKnots  knots of Bezier/B-spline curve (with repetitions)
-  //! \param thePoles2d    array of poles of 2D curve
-  //! \param theWeights    array of weights of corresponding poles
-  Standard_EXPORT BSplCLib_Cache(const Standard_Integer&        theDegree,
-                                 const Standard_Boolean&        thePeriodic,
-                                 const TColStd_Array1OfReal&    theFlatKnots,
-                                 const TColgp_Array1OfPnt2d&    thePoles2d,
-                                 const TColStd_Array1OfReal*    theWeights = NULL);
-  //! Constructor for caching of 3D curves
-  //! \param theDegree     degree of the curve
-  //! \param thePeriodic   identify the curve is periodic
-  //! \param theFlatKnots  knots of Bezier/B-spline curve (with repetitions)
-  //! \param thePoles      array of poles of 3D curve
-  //! \param theWeights    array of weights of corresponding poles
-  Standard_EXPORT BSplCLib_Cache(const Standard_Integer&        theDegree,
-                                 const Standard_Boolean&        thePeriodic,
-                                 const TColStd_Array1OfReal&    theFlatKnots,
-                                 const TColgp_Array1OfPnt&      thePoles,
-                                 const TColStd_Array1OfReal*    theWeights = NULL);
 
   //! Verifies validity of the cache using flat parameter of the point
   //! \param theParameter parameter of the point placed in the span
   Standard_EXPORT Standard_Boolean IsCacheValid(Standard_Real theParameter) const;
 
   //! Recomputes the cache data for 2D curves. Does not verify validity of the cache
-  //! \param theParameter  the value on the knot's axis to identify the span
   //! \param theDegree     degree of the curve
   //! \param thePeriodic   identify the curve is periodic
   //! \param theFlatKnots  knots of Bezier/B-spline curve (with repetitions)
+  //! \param theCachedSpan index of span to be cached
   //! \param thePoles2d    array of poles of 2D curve
   //! \param theWeights    array of weights of corresponding poles
-  Standard_EXPORT void BuildCache(const Standard_Real&           theParameter,
-                                  const Standard_Integer&        theDegree,
-                                  const Standard_Boolean&        thePeriodic,
-                                  const TColStd_Array1OfReal&    theFlatKnots,
-                                  const TColgp_Array1OfPnt2d&    thePoles2d,
-                                  const TColStd_Array1OfReal*    theWeights = NULL);
+  Standard_EXPORT void BuildCache(const Standard_Integer      theDegree,
+                                  const Standard_Boolean      thePeriodic,
+                                  const TColStd_Array1OfReal& theFlatKnots,
+                                  const Standard_Integer      theCachedSpan,
+                                  const TColgp_Array1OfPnt2d& thePoles2d,
+                                  const TColStd_Array1OfReal* theWeights = NULL);
   //! Recomputes the cache data for 3D curves. Does not verify validity of the cache
-  //! \param theParameter  the value on the knot's axis to identify the span
   //! \param theDegree     degree of the curve
   //! \param thePeriodic   identify the curve is periodic
   //! \param theFlatKnots  knots of Bezier/B-spline curve (with repetitions)
+  //! \param theCachedSpan index of span to be cached
   //! \param thePoles      array of poles of 3D curve
   //! \param theWeights    array of weights of corresponding poles
-  Standard_EXPORT void BuildCache(const Standard_Real&           theParameter,
-                                  const Standard_Integer&        theDegree,
-                                  const Standard_Boolean&        thePeriodic,
-                                  const TColStd_Array1OfReal&    theFlatKnots,
-                                  const TColgp_Array1OfPnt&      thePoles,
-                                  const TColStd_Array1OfReal*    theWeights = NULL);
+  Standard_EXPORT void BuildCache(const Standard_Integer      theDegree,
+                                  const Standard_Boolean      thePeriodic,
+                                  const TColStd_Array1OfReal& theFlatKnots,
+                                  const Standard_Integer      theCachedSpan,
+                                  const TColgp_Array1OfPnt&   thePoles,
+                                  const TColStd_Array1OfReal* theWeights = NULL);
 
   //! Calculates the point on the curve in the specified parameter
   //! \param[in]  theParameter parameter of calculation of the value
   //! \param[out] thePoint     the result of calculation (the point on the curve)
-  Standard_EXPORT void D0(const Standard_Real& theParameter, gp_Pnt2d& thePoint) const;
-  Standard_EXPORT void D0(const Standard_Real& theParameter, gp_Pnt&   thePoint) const;
+  Standard_EXPORT void D0(const Standard_Real theParameter, gp_Pnt2d& thePoint) const;
+  Standard_EXPORT void D0(const Standard_Real theParameter, gp_Pnt&   thePoint) const;
 
   //! Calculates the point on the curve and its first derivative in the specified parameter
   //! \param[in]  theParameter parameter of calculation of the value
   //! \param[out] thePoint     the result of calculation (the point on the curve)
   //! \param[out] theTangent   tangent vector (first derivatives) for the curve in the calculated point
-  Standard_EXPORT void D1(const Standard_Real& theParameter, gp_Pnt2d& thePoint, gp_Vec2d& theTangent) const;
-  Standard_EXPORT void D1(const Standard_Real& theParameter, gp_Pnt&   thePoint, gp_Vec&   theTangent) const;
+  Standard_EXPORT void D1(const Standard_Real theParameter, gp_Pnt2d& thePoint, gp_Vec2d& theTangent) const;
+  Standard_EXPORT void D1(const Standard_Real theParameter, gp_Pnt&   thePoint, gp_Vec&   theTangent) const;
 
   //! Calculates the point on the curve and two derivatives in the specified parameter
   //! \param[in]  theParameter parameter of calculation of the value
   //! \param[out] thePoint     the result of calculation (the point on the curve)
   //! \param[out] theTangent   tangent vector (1st derivatives) for the curve in the calculated point
   //! \param[out] theCurvature curvature vector (2nd derivatives) for the curve in the calculated point
-  Standard_EXPORT void D2(const Standard_Real& theParameter, 
-                                gp_Pnt2d&      thePoint, 
-                                gp_Vec2d&      theTangent, 
-                                gp_Vec2d&      theCurvature) const;
-  Standard_EXPORT void D2(const Standard_Real& theParameter, 
-                                gp_Pnt&        thePoint, 
-                                gp_Vec&        theTangent, 
-                                gp_Vec&        theCurvature) const;
+  Standard_EXPORT void D2(const Standard_Real theParameter, 
+                                gp_Pnt2d&     thePoint, 
+                                gp_Vec2d&     theTangent, 
+                                gp_Vec2d&     theCurvature) const;
+  Standard_EXPORT void D2(const Standard_Real theParameter, 
+                                gp_Pnt&       thePoint, 
+                                gp_Vec&       theTangent, 
+                                gp_Vec&       theCurvature) const;
 
   //! Calculates the point on the curve and three derivatives in the specified parameter
   //! \param[in]  theParameter parameter of calculation of the value
@@ -127,34 +105,29 @@ public:
   //! \param[out] theTangent   tangent vector (1st derivatives) for the curve in the calculated point
   //! \param[out] theCurvature curvature vector (2nd derivatives) for the curve in the calculated point
   //! \param[out] theTorsion   second curvature vector (3rd derivatives) for the curve in the calculated point
-  Standard_EXPORT void D3(const Standard_Real& theParameter, 
-                                gp_Pnt2d&      thePoint, 
-                                gp_Vec2d&      theTangent, 
-                                gp_Vec2d&      theCurvature,
-                                gp_Vec2d&      theTorsion) const;
-  Standard_EXPORT void D3(const Standard_Real& theParameter, 
-                                gp_Pnt&        thePoint, 
-                                gp_Vec&        theTangent, 
-                                gp_Vec&        theCurvature,
-                                gp_Vec&        theTorsion) const;
+  Standard_EXPORT void D3(const Standard_Real theParameter, 
+                                gp_Pnt2d&     thePoint, 
+                                gp_Vec2d&     theTangent, 
+                                gp_Vec2d&     theCurvature,
+                                gp_Vec2d&     theTorsion) const;
+  Standard_EXPORT void D3(const Standard_Real theParameter, 
+                                gp_Pnt&       thePoint, 
+                                gp_Vec&       theTangent, 
+                                gp_Vec&       theCurvature,
+                                gp_Vec&       theTorsion) const;
 
 
   DEFINE_STANDARD_RTTIEXT(BSplCLib_Cache,Standard_Transient)
 
 protected:
-  //! Normalizes the parameter for periodical curves
-  //! \param theFlatKnots knots with repetitions
-  //! \param theParameter the value to be normalized into the knots array
-  void PeriodicNormalization(const TColStd_Array1OfReal& theFlatKnots, Standard_Real& theParameter) const;
-
   //! Fills array of derivatives in the selected point of the curve
   //! \param[in]  theParameter  parameter of the calculation
   //! \param[in]  theDerivative maximal derivative to be calculated (computes all derivatives lesser than specified)
   //! \param[out] theDerivArray result array of derivatives (with size (theDerivative+1)*(PntDim+1), 
   //!                           where PntDim = 2 or 3 is a dimension of the curve)
-  void CalculateDerivative(const Standard_Real&    theParameter, 
-                           const Standard_Integer& theDerivative, 
-                                 Standard_Real&    theDerivArray) const;
+  void CalculateDerivative(const Standard_Real    theParameter, 
+                           const Standard_Integer theDerivative, 
+                                 Standard_Real&   theDerivArray) const;
 
 private:
   Handle(TColStd_HArray2OfReal) myPolesWeights; ///< array of poles and weights of calculated cache
@@ -163,14 +136,13 @@ private:
                                                 //       x2 y2 [z2] [w2] etc
                                                 // for 2D-curves there is no z conponent, for non-rational curves there is no weight
 
-  Standard_Boolean              myIsRational; ///< identifies the rationality of Bezier/B-spline curve
-  Standard_Real                 mySpanStart;  ///< parameter for the first point of the span
-  Standard_Real                 mySpanLength; ///< length of the span
-  Standard_Integer              mySpanIndex;  ///< index of the span on Bezier/B-spline curve
+  Standard_Boolean              myIsRational;   ///< identifies the rationality of Bezier/B-spline curve
+  Standard_Real                 mySpanStart;    ///< parameter for the first point of the span
+  Standard_Real                 mySpanLength;   ///< length of the span
+  Standard_Integer              mySpanIndex;    ///< index of the span on Bezier/B-spline curve
   Standard_Integer              mySpanIndexMin; ///< minimal index of span on Bezier/B-spline curve
   Standard_Integer              mySpanIndexMax; ///< maximal number of spans on Bezier/B-spline curve
-  Standard_Integer              myDegree;     ///< degree of Bezier/B-spline
-  Handle(TColStd_HArray1OfReal) myFlatKnots;  ///< knots of Bezier/B-spline (used for periodic normalization of parameters, exists only for periodical splines)
+  Standard_Integer              myDegree;       ///< degree of Bezier/B-spline
 };
 
 DEFINE_STANDARD_HANDLE(BSplCLib_Cache, Standard_Transient)
